'\" te
.\" Copyright (c) 2001, the Institute of Electrical and Electronics Engineers, Inc. and The Open Group. All Rights Reserved.
.\" Copyright (c) 1992, X/Open Company Limited.  All Rights Reserved.
.\" Portions Copyright (c) 2006, Sun Microsystems, Inc. All Rights Reserved.
.\" Sun Microsystems, Inc. gratefully acknowledges The Open Group for permission to reproduce portions of its copyrighted documentation. Original documentation from The Open Group can be obtained online at 
.\" http://www.opengroup.org/bookstore/.
.\" The Institute of Electrical and Electronics Engineers and The Open Group, have given us permission to reprint portions of their documentation. In the following statement, the phrase "this text" refers to portions of the system documentation. Portions of this text are reprinted and reproduced in electronic form in the Sun OS Reference Manual, from IEEE Std 1003.1, 2004 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2004 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between these versions and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html.
.\"  This notice shall appear on any product containing this material.
.\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License").  You may not use this file except in compliance with the License.
.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.  See the License for the specific language governing permissions and limitations under the License.
.\" When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE.  If applicable, add the following below this CDDL HEADER, with the fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
.TH modf 3M "12 Jul 2006" "SunOS 5.11" "Mathematical Library Functions"
.SH NAME
modf, modff, modfl \- decompose floating-point number
.SH SYNOPSIS
.LP
.nf
c99 [ \fIflag\fR... ] \fIfile\fR... \fB-lm\fR [ \fIlibrary\fR... ]
#include <math.h>

\fBdouble\fR \fBmodf\fR(\fBdouble\fR \fIx\fR, \fBdouble *\fR\fIiptr\fR);
.fi

.LP
.nf
\fBfloat\fR \fBmodff\fR(\fBfloat\fR \fIx\fR, \fBfloat *\fR\fIiptr\fR);
.fi

.LP
.nf
\fBlong double\fR \fBmodfl\fR(\fBlong double\fR \fIx\fR, \fBlong double *\fR\fIiptr\fR);
.fi

.SH DESCRIPTION
.sp
.LP
These functions break the argument \fIx\fR into integral and fractional parts,
each of which has the same sign as the argument. It stores the integral part as
a \fBdouble\fR for the \fBmodf()\fR function, a float for the \fBmodff()\fR
function, or a long double for the\fBmodfl()\fR function in the object pointed
to by \fIiptr\fR.
.SH RETURN VALUES
.sp
.LP
Upon successful completion, these functions return the signed fractional part
of \fIx\fR.
.sp
.LP
If \fIx\fR is NaN, a NaN is returned and *\fIiptr\fR is set to NaN.
.sp
.LP
If \fIx\fR is \(+-Inf, \(+-0 is returned and *\fIiptr\fR is set to \(+-Inf.
.SH ERRORS
.sp
.LP
No errors are defined.
.SH USAGE
.sp
.LP
These functions compute the function result and *\fIiptr\fR such that:
.sp
.in +2
.nf
a = modf(x, &iptr) ;
x == a+*iptr ;
.fi
.in -2

.SH ATTRIBUTES
.sp
.LP
See \fBattributes\fR(5) for descriptions of the following attributes:
.sp

.sp
.TS
tab() box;
cw(2.75i) |cw(2.75i) 
lw(2.75i) |lw(2.75i) 
.
ATTRIBUTE TYPEATTRIBUTE VALUE
_
Interface StabilityStandard
_
MT-LevelMT-Safe
.TE

.SH SEE ALSO
.sp
.LP
\fBfrexp\fR(3M), \fBisnan\fR(3M), \fBldexp\fR(3M), \fBattributes\fR(5),
\fBstandards\fR(5)
